#include <bits/stdc++.h>
#define ll long long
using namespace std;
int N,K,ps[30][100005],br;
char S[100005];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>N>>K;
    for(int i=1;i<=N;i++){
        cin>>S[i];
        ps[S[i]-96][i]=1;
    }
    for(int i=1;i<=K;i++){
        for(int j=1;j<=N;j++){
            ps[i][j]+=ps[i][j-1];
        }
    }
    br=1;
    bool au;
    for(int i=1;i<=N;i++){
            int mini=1e9;
            int jpoz=0;
            bool sviisti=true;
        for(int j=1;j<=K;j++){
            if(!ps[j][i]){cout<<br<<" ";break;}
        }
        for(int j=1;j<=K;j++){
             mini=min(ps[j][i],mini);
            if(ps[j][i]==mini)jpoz=j;
            if(ps[j][i-1]<ps[j][i])au=true;
            else au=false;
            }
            if(au)br++;


//        for(int j=2;j<=K;j++){
//             sviisti=(sviisti && ps[j][i]==ps[j-1][i]);
//        }
//        if(sviisti)br++;
        cout<<br<<" ";
    }
return 0;
}